IMPLEMENTATION MODULE IOVorgang;
 
FROM Storage     IMPORT ALLOCATE,DEALLOCATE,Available;
FROM Terminal    IMPORT WriteLn,WriteString,Read;
FROM MySystem    IMPORT FullSize,Cls;
FROM InOut       IMPORT ReadCard,WriteCard;
FROM Strings     IMPORT Compare,Length;
FROM FileNames   IMPORT ReadFileName,noEcho;
FROM FileSystem  IMPORT Lookup,Close,ReadBytes,ReadChar,WriteBytes,WriteChar,
                        File,done;
FROM FileMessage IMPORT ResponseText,StrPtr;
FROM Init        IMPORT WortPtr,Wort,Warten,String;
FROM SYSTEM      IMPORT ADR;
FROM ASCII       IMPORT eol;
  
VAR filename               : ARRAY [0..20] OF CHAR;
    file                   : File;
    erfolgreich            : BOOLEAN;
    laenge                 : INTEGER;              


PROCEDURE Pruefen (file : File) : BOOLEAN;

  VAR meldungpointer : StrPtr;
  
  BEGIN
    IF file.res = done THEN 
      RETURN TRUE;
    ELSE
      ResponseText(file.res,meldungpointer);
      WriteString('     ACHTUNG : ');
      WriteString(meldungpointer^);
      WriteLn;
      RETURN FALSE;
    END;
  END Pruefen;

                  (******************************)
          
PROCEDURE IOWortLaden(VAR Ezeiger : ARRAY OF WortPtr;VAR wortanzahl : CARDINAL);

  CONST schreiben = FALSE;
    
  VAR wort                   : Wort;
      wortzeiger,hilfszeiger : WortPtr;
      Senglisch,Sdeutsch       : String;
      dummy                  : CHAR;
      i                      : CARDINAL;
      actual                 : LONGINT;
       
  BEGIN
    Cls;
    WriteLn;
    WriteLn;
    WriteString('        Name des Wrterbuches : ');
    ReadFileName(filename,laenge,Read,noEcho);
    WriteLn;
    Lookup(file,filename,0,schreiben);
    erfolgreich := Pruefen(file);
    IF NOT erfolgreich THEN 
      Warten;
      RETURN;
    END;
    wortzeiger := Ezeiger[0];
    WHILE wortzeiger # NIL DO
      hilfszeiger := wortzeiger^.nextEzgr;
      DEALLOCATE(wortzeiger,SIZE(wortzeiger^));
      wortzeiger := hilfszeiger;
    END;
    LOOP
      ReadBytes(file,ADR(Senglisch),16,actual);
      ReadBytes(file,ADR(Sdeutsch),16,actual);
      ReadChar(file,dummy);
      ReadChar(file,dummy);
      IF file.eof THEN EXIT END;
      erfolgreich := Pruefen(file);
      IF NOT erfolgreich THEN
        Warten;
        EXIT;
      END;   
      IF Available(SIZE(wortzeiger^)) THEN
        ALLOCATE(wortzeiger,SIZE(wortzeiger^));
        IF wortanzahl = 0 THEN 
          Ezeiger [0]          := wortzeiger; 
        ELSE
          hilfszeiger^.nextEzgr := wortzeiger;
        END;
        wortzeiger^.nextEzgr  := NIL;
        hilfszeiger           := wortzeiger;
        FOR i := 0 TO 15 DO
          IF Senglisch[i] = ' ' THEN
            Senglisch[i] := 0C;
            i := 15;
          END;
        END;
        FOR i := 0 TO 15 DO
          IF Sdeutsch[i] = ' ' THEN
            Sdeutsch[i] := 0C;
            i := 15;
          END;
        END;        
        WITH wortzeiger^ DO
          englisch     := Senglisch;
          deutsch      := Sdeutsch;
        END;
        INC(wortanzahl);
      ELSE
        WriteString('  kein Speicherplatz mehr !!');
        Warten;
        EXIT;
      END;
    END; 
    Close(file);
  END IOWortLaden;  


                  (******************************)        

PROCEDURE Unterteilen(VAR Ezeiger : ARRAY OF WortPtr;wortanzahl : CARDINAL);     
  
  VAR gruppenanzahl,i,j   : CARDINAL;
      variabelzeiger      : WortPtr;
      
  BEGIN    
    gruppenanzahl := wortanzahl DIV 10;
    variabelzeiger := Ezeiger [0];
    FOR i := 1 TO 9 DO
      FOR j := 1 TO gruppenanzahl DO
        variabelzeiger := variabelzeiger^.nextEzgr;
      END;
      Ezeiger [i] := variabelzeiger;  
    END;
  END Unterteilen;  

                  (******************************)

PROCEDURE Laden(VAR Ezeiger : ARRAY OF WortPtr;
                VAR wortanzahl : CARDINAL);

  BEGIN
    wortanzahl := 0;
    IOWortLaden(Ezeiger,wortanzahl);
    IF wortanzahl = 0 THEN 
      RETURN;
    END;
    WriteLn; 
    WriteString('        Es wurden ');
    WriteCard(wortanzahl,5);
    WriteString(' Wortdaten gelesen');
    WriteLn;
    Unterteilen(Ezeiger,wortanzahl);
    Warten;
  
  END Laden; 
  
                  (******************************)
                  
PROCEDURE Speichern(VAR fest : WortPtr;VAR wortanzahl : CARDINAL);

  CONST schreiben = TRUE;  
  
  VAR store,hilfszeiger,variabel  : WortPtr;
      actual                      : LONGINT;
      i,j,wortzahl                : CARDINAL;
      
  BEGIN
    Cls;
    WriteLn;
    WriteLn;
    variabel := fest;
    store := variabel;
    IF variabel = NIL THEN 
      WriteString('    Kein Wrterbuch im Speicher !');
      WriteLn;
      Warten;
      RETURN;
    END;
    WriteString('      Name des Wrterbuches : ');
    ReadFileName(filename,laenge,Read,noEcho);
    WriteLn;
    WriteLn;
    WriteLn;
    Lookup(file,filename,0,schreiben);
    erfolgreich := Pruefen(file);
    IF NOT erfolgreich THEN 
      Warten;
      RETURN;
    END;
    wortzahl := 0;
    LOOP
      IF variabel = NIL THEN 
        EXIT
      ELSE
        INC(wortzahl);
      END;  
      FOR i := 0 TO 15 DO
        IF variabel^.englisch[i] = 0C THEN
          FOR j := i TO 15 DO variabel^.englisch[j] := ' ' END;
          i := 15;
        END;
      END;
      FOR i := 0 TO 15 DO
        IF variabel^.deutsch[i] = 0C THEN
          FOR j := i TO 15 DO variabel^.deutsch[j] := ' ' END;
          i := 15;
        END;
      END;
      WriteBytes(file,ADR(variabel^.englisch),16,actual);
      WriteBytes(file,ADR(variabel^.deutsch),16,actual);
      WriteChar(file,'|');
      WriteChar(file,eol);
      variabel := variabel^.nextEzgr;
    END;   
    erfolgreich := Pruefen(file);
    IF NOT erfolgreich THEN 
      Warten;
      RETURN;
    END;
    Close(file);
    WriteString('      Es wurden ');
    WriteCard(wortzahl,5);
    WriteString(' Wrter geschrieben');
    WHILE store # NIL DO
      hilfszeiger := store^.nextEzgr;
      DEALLOCATE(store,SIZE(store^));
      store := hilfszeiger;
    END;
    fest       := NIL;
    wortanzahl := 0;
    WriteLn;
    WriteLn;
    Warten;
  END Speichern; 
  
                                  
END IOVorgang.
